Redmine - Defect #27560

RJS is messing up Nginx proxy for static files
2017-11-18 11:17 - Erwin Mueller

Status: Closed Start date:

Priority: Normal Due date:

Assignee: % Done: 0%
Category: ul Estimated time: 0.00 hour
Target version:

Resolution: Duplicate Affected version: 3.4.3
Description

| have a simple Redmine+Nginx setup and | upgraded to the latest Redmine version. | see that the following is not working:

e issues: switch version, switch tracker
¢ custom field: switch format
e probably a lot more

The issue is that | have the following Nginx configuration:

location ~* ~.+\.(?:css|js|Jjpe?glgif|htc|icolpng|html)$

That is fairly common to serve static files directly and make use of Nginx speed. But it breaks RJS apparently.
Because you have this requests:

<script>
/ /<! [CDATA[

S ('#custom_field_field_format') .change (function () {
S.ajax ({
url: '/custom_fields/new.js"',
type: 'get',
data: $('#custom_field_form').serialize(),
complete: toggleDisabledInit
1) i
}) i

/711>

</script>
And Nginx returns a 404:

nginx_1 | 2017/11/18 09:50:09 [error] 18#18: *53 open() "/var/www/html/public/custom_fields/new
.Jjs" failed (2: No such file or directory), client: 192.168.80.1, server: _, request: "GET /custom
_fields/new. js?utf8=%E2%9C%93&authenticity_token=xBi4111xH%2FNxCGxOPy1355fFA8Z5nvJ6cUKKuOIJm3UjR13X
VRKO JmPwbEIM1gQcXjxPkJuxr8e316t zKK$2BGL%2Bw%$3D%3D&custom_field%5Bfield_format%$5D=bool&custom_field
%$5Bname%5D=Affected+Version&custom_field%$5Bdescription%5D=&custom_field%5Bmin_length%5D=&custom_fi
eld%5Bmax_length%5D=&custom_field%5Bregexp%bD=&custom_field%5Btext_formatting$5D=&custom_field%5Bd
efault_value%5D=&custom_field%5Burl_pattern%5D=&custom_field%$5Bis_required%$5D=0&custom_field%5Bis_
required$5D=1&custom_field%5Bis_filter%5D=0&custom_field%5Bis_filter%$5D=1&custom_field%5Bsearchabl
e%$5D=0&custom_field%5Bsearchable%5D=1&custom_field%5Bvisible%5D=1&custom_field%5Brole_1ds%$5D%5B%5D
=&custom_field%5Btracker_i1ds%5D%5B%5D=1&custom_field%5Btracker_i1ds%5D%5B%5D=&custom_field%5Bis_for
_all%5D=0&custom_field%5Bproject_ids%$5D%5B%5D=&type=IssueCustomField HTTP/1.1", host: "localhost:8
080", referrer: "http://localhost:8080/custom_fields/new?utf8=%E2%9C%93&type=IssueCustomField"

Nginx sees a request to new.js and thinks it's a static file and tries to serve it directly.
RJS shouldn't be used anyway: #15560
Workaround:

Add a new location for new.js and let it serve from the Rails server.
https://www.redmine.org/issues/15560

location ~* ~.+new\.]js$ {
proxy_pass http://redmine:3000;

Related issues:
Is duplicate of Redmine - Defect #17770: very simple fix: that causes many ... New

History

#1 - 2017-11-18 11:24 - Erwin Mueller

RJS shouldn't be used anyway: #15560

Of course that's just a suggestion :) Renaming new.js to something like new.rjs would also be nice.

#2 - 2017-12-03 19:26 - Toshi MARUYAMA
- Status changed from New to Closed

- Resolution set to Duplicate

Duplicate of #17770.

#3 - 2017-12-03 19:27 - Toshi MARUYAMA

- Is duplicate of Defect #17770: very simple fix: that causes many sites to break, and much confusion - incorrect use of .js suffix added
